package com.xxl.job.admin.core.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

public class LocalCacheUtil {
  private static ConcurrentMap<String, LocalCacheData> cacheRepository = new ConcurrentHashMap<>();
  
  public static boolean set(String key, Object val, long cacheTime) {
    cleanTimeoutCache();
    if (key == null || key.trim().length() == 0)
      return false; 
    if (val == null)
      remove(key); 
    if (cacheTime <= 0L)
      remove(key); 
    long timeoutTime = System.currentTimeMillis() + cacheTime;
    LocalCacheData localCacheData = new LocalCacheData(key, val, timeoutTime);
    cacheRepository.put(localCacheData.getKey(), localCacheData);
    return true;
  }
  
  public static boolean remove(String key) {
    if (key == null || key.trim().length() == 0)
      return false; 
    cacheRepository.remove(key);
    return true;
  }
  
  public static Object get(String key) {
    if (key == null || key.trim().length() == 0)
      return null; 
    LocalCacheData localCacheData = cacheRepository.get(key);
    if (localCacheData != null && System.currentTimeMillis() < localCacheData.getTimeoutTime())
      return localCacheData.getVal(); 
    remove(key);
    return null;
  }
  
  public static boolean cleanTimeoutCache() {
    if (!cacheRepository.keySet().isEmpty())
      for (String key : cacheRepository.keySet()) {
        LocalCacheData localCacheData = cacheRepository.get(key);
        if (localCacheData != null && System.currentTimeMillis() >= localCacheData.getTimeoutTime())
          cacheRepository.remove(key); 
      }  
    return true;
  }
}
